--[[
PSP Air Hockey Version 0.2
by Carlos Aldana AKA indianajonesilm

Thanks to Shine and nevyn for LUA Player!
Thanks to Shine for menu example code!
Thanks to nevyn for paddle movement acceleration! 
 
--]]

-- load images
	paddleimg = Image.load("pad.png")
	background = Image.load("background.png")
	backgroundlarge = Image.load("backgroundlarge.png")
   background2 = Image.load("background2.png")
   background2large = Image.load("background2large.png")
	splash = Image.load("luasplash.png")
	puckimg = Image.load("puck.png")
   menuimg = Image.load("menu.png")
   mainmenuimg = Image.load("mainmenu.png")



-- load sounds
   goalsnd = Sound.load("goal.wav")
   hitsnd = Sound.load("hit.wav")
   wallsnd = Sound.load("wall.wav")
   boltsnd= Sound.load("comp.wav")


--default values
options = { puckspeed = 3, background = 2, paddlespeed = 2, goalsize = 1, music = 1 }

possibleOptions = {
   puckspeed = {
      displayName = "Puck Speed",
      values = { 1, 2, 3} },
   background = {
      displayName = "Background Image",
      values = { 1, 2} },
   paddlespeed = {
      displayName = "Paddle Speed",
      values = { 1, 2, 3} },
   goalsize = {
      displayName = "Goal Size",
      values = { 1, 2} },
   music = {
      displayName = "Music",
      values = { 1, 2, 3} }
}

puckvel = 6
red = Color.new(255, 0, 0)
black = Color.new(0, 0, 0)

-- set up paddle start positions
	paddle = {{}, {}}
	paddle[1].x = 70
	paddle[1].y = 120
	paddle[1].xa = 0
	paddle[1].ya = 0
	paddle[2].x = 378
	paddle[2].y = 120
	paddle[2].xa = 0
	paddle[2].ya = 0	
	
	accel = .6
   accela = 1

-- set up puck start position for testing purposes
	puck_pos = {{},{}}
	puck_pos.x = 224
	puck_pos.y = 120
	
	puck_center = {{},{}}
	puck_center.x = puck_pos.x + 16
	puck_center.y = puck_pos.y + 16

	paddle_center = {{},{}}
	paddle_center[1].x = paddle[1].x + 16
	paddle_center[1].y = paddle[1].y + 16
	paddle_center[2].x = paddle[2].x + 16
	paddle_center[2].y = paddle[2].y + 16

	puck_velocity = {{},{}}
	puck_velocity.y = math.random(-6,6)
   puck_velocity.x = math.random(1,2)
   if puck_velocity.x == 2 then
   puck_velocity.x = 6                                           
   else
   puck_velocity.x = -6
   end


-- Function for paddle movement
function keyboardControl()
	
	pad = Controls.read()
	if pad:up() then
		paddle[1].ya = paddle[1].ya -accel
	elseif pad:down() then
		paddle[1].ya = paddle[1].ya +accel
	elseif pad:left() then
		paddle[1].xa = paddle[1].xa -accel
	elseif pad:right() then
		paddle[1].xa = paddle[1].xa +accel
	end

if players == 2 then
	if pad:triangle() then
		paddle[2].ya = paddle[2].ya -accel
	elseif pad:cross() then
		paddle[2].ya = paddle[2].ya +accel
	elseif pad:square() then
		paddle[2].xa = paddle[2].xa -accel
	elseif pad:circle() then
		paddle[2].xa = paddle[2].xa +accel
	end
end

   dx = pad:analogX()
   if math.abs(dx) > 32 then
      if dx > 32 then
         paddle[1].xa = ((paddle[1].xa + dx) / 32) +accela
      elseif dx < 32 then
         paddle[1].xa = ((paddle[1].xa + dx) / 32) -accela
      end
   end

   dy = pad:analogY()
   if math.abs(dy) > 32 then
      if dy > 32 then
         paddle[1].ya = ((paddle[1].ya + dy) / 32) +accela
      elseif dy < 32 then
         paddle[1].ya = ((paddle[1].ya + dy) / 32) -accela
      end
   end

   if pad:start() then
      screen.waitVblankStart(30)
		return "mmenu"
   end
end


--Function for paddle maximum movement border
function paddlemaxborder()
	border = {{}, {}}
	border[1].x = {5,202}
	border[1].y = {5,235}
	border[2].x = {244, 442}
	border[2].y = {5,235}

	for player, coords in ipairs(border) do
		for coord, borders in coords do
			if paddle[player][coord] < borders[1] then
				paddle[player][coord] = borders[1]
				paddle[player][coord.."a"] = -0.2*paddle[player][coord.."a"] -- slight bounce
			elseif paddle[player][coord] > borders[2] then
				paddle[player][coord] = borders[2]
				paddle[player][coord.."a"] = -0.2*paddle[player][coord.."a"]
			end
		end
	end
end	

--Function that determines wether or not the puck has collided with a wall.
function didPuckWallCollide()
	if puck_pos.x <= 5 and puck_pos.y <= 79 then
		wallsnd:play()
      puck_pos.x = puck_pos.x - puck_velocity.x
		puck_velocity.x = -puck_velocity.x
	end
	if puck_pos.x <= 5 and puck_pos.y >= 161 then
		wallsnd:play()
      puck_pos.x = puck_pos.x - puck_velocity.x
		puck_velocity.x = -puck_velocity.x
  	end

	if puck_pos.y <= 5 then
		wallsnd:play()
      puck_pos.y = puck_pos.y - puck_velocity.y
		puck_velocity.y = -puck_velocity.y
 	end
	if puck_pos.x >= 443 and puck_pos.y <= 79 then
		wallsnd:play()
      puck_pos.x = puck_pos.x - puck_velocity.x
		puck_velocity.x = -puck_velocity.x
  	end
	
	if puck_pos.x >= 443 and puck_pos.y >= 161 then
		wallsnd:play()
      puck_pos.x = puck_pos.x - puck_velocity.x
		puck_velocity.x = -puck_velocity.x
 	end
	if puck_pos.y >= 235 then
		wallsnd:play()
      puck_pos.y = puck_pos.y - puck_velocity.y
		puck_velocity.y = -puck_velocity.y
 	end
end	

function didPuckWallCollide2()
	if puck_pos.x <= 5 and puck_pos.y <= 57 then
		wallsnd:play()
      puck_pos.x = puck_pos.x - puck_velocity.x
		puck_velocity.x = -puck_velocity.x
	end
	if puck_pos.x <= 5 and puck_pos.y >= 183 then
		wallsnd:play()
      puck_pos.x = puck_pos.x - puck_velocity.x
		puck_velocity.x = -puck_velocity.x
  	end

	if puck_pos.y <= 5 then
		wallsnd:play()
      puck_pos.y = puck_pos.y - puck_velocity.y
		puck_velocity.y = -puck_velocity.y
 	end
	if puck_pos.x >= 443 and puck_pos.y <= 57 then
		wallsnd:play()
      puck_pos.x = puck_pos.x - puck_velocity.x
		puck_velocity.x = -puck_velocity.x
  	end
	
	if puck_pos.x >= 443 and puck_pos.y >= 183 then
		wallsnd:play()
      puck_pos.x = puck_pos.x - puck_velocity.x
		puck_velocity.x = -puck_velocity.x
 	end
	if puck_pos.y >= 235 then
		wallsnd:play()
      puck_pos.y = puck_pos.y - puck_velocity.y
		puck_velocity.y = -puck_velocity.y
 	end
end	

--Function that determines wether or not the puck has entered a goal.
function isPuckInGoal()
	if puck_pos.x < 5 and puck_pos.y > 79 and puck_pos.y < 161 then
		score1 = score1 +1
      goalsnd:play()
		return "true"
	end

	if puck_pos.x > 443 and puck_pos.y > 79 and puck_pos.y < 161 then
		score2 = score2 +1
      goalsnd:play()
		return "true"
	end
	
end
function isPuckInGoal2()
	if puck_pos.x < 5 and puck_pos.y > 57 and puck_pos.y < 183 then
		score1 = score1 +1
      goalsnd:play()
		return "true"
	end

	if puck_pos.x > 443 and puck_pos.y > 57 and puck_pos.y < 183 then
		score2 = score2 +1
      goalsnd:play()
		return "true"
	end
	
end

--Function that determines wether or not the puck has collided with a paddle.

--If the distance between the centers of the Paddle and the Puck are less than the sum of their radii then they intersect.

function hasPuckPaddleCollided()
	
   xdist1 = math.abs (puck_center.x - paddle_center[1].x)
  	ydist1 = math.abs (puck_center.y - paddle_center[1].y)
   if xdist1 < 32 and ydist1 <32 then
      hitsnd:play()
	return "collide1"
	end
   xdist2 = math.abs (puck_center.x - paddle_center[2].x)
  	ydist2 = math.abs (puck_center.y - paddle_center[2].y)
   if xdist2 < 32 and ydist2 <32 then
      hitsnd:play()
	return "collide2"
	end

end

--Function to calculate a new motion vector for the puck after it has collided with a paddle.
function ChangePuckVelocity1()

 	--xcomp, ycomp = components of the velocity along X and y axes
  	--xdist, ydist = x and y distance of the puck and paddle
  	--val = magnitude of puck velocity
  	--alpha = angle of the velocity vector
  	--theta = angle created by the distance between paddle and puck
  	--result = resultant vector of the deflecting puck
  	--xmultiplier=1,ymultiplier=1 = transformation constants



	xmultiplier=1
	ymultiplier=1

	-- If puck is to the left of the paddle, move it to the right of the paddle.
	if puck_center.x < paddle_center[1].x then
	xmultiplier = -1
	end
	
	--If puck is above the paddle, move it below the paddle.
	if puck_center.y < paddle_center[1].y then
	ymultiplier = -1
	end

	--determine the x and y distances
  	xdist = math.abs (puck_center.x - paddle_center[1].x)
  	ydist = math.abs (puck_center.y - paddle_center[1].y)
	
	--transform the puck velocity 
	xcomp = puck_velocity.x*xmultiplier
  	ycomp = puck_velocity.y*ymultiplier
  	val = math.sqrt(xcomp*xcomp + ycomp*ycomp)
	
	-- get velocity and distance angles
  	alpha = math.atan(ycomp/xcomp)
  	theta = math.atan(ydist/xdist)

 	--determine resultant angle of deflecting puck
  	result = math.pi - 2*alpha - theta

	-- compute the actual velocity components by multiplying
 	-- with the corresponding multipliers.

	puck_velocity.x = xmultiplier*math.abs(val*math.cos(result))
  	puck_velocity.y = ymultiplier*math.abs(val*math.sin(result))
end

function ChangePuckVelocity2()

 	xmultiplier=1
	ymultiplier=1

	-- If puck is to the left of the paddle, move it to the right of the paddle.
	if puck_center.x < paddle_center[2].x then
	xmultiplier = -1
	end
	
	--If puck is above the paddle, move it below the paddle.
	if puck_center.y < paddle_center[2].y then
	ymultiplier = -1
	end

	--determine the x and y distances
  	xdist = math.abs (puck_center.x - paddle_center[2].x)
  	ydist = math.abs (puck_center.y - paddle_center[2].y)
	
	--transform the puck velocity 
	xcomp = puck_velocity.x*xmultiplier
  	ycomp = puck_velocity.y*ymultiplier
  	val = math.sqrt(xcomp*xcomp + ycomp*ycomp)
	
	-- get velocity and distance angles
  	alpha = math.atan(ycomp/xcomp)
  	theta = math.atan(ydist/xdist)

 	--determine resultant angle of deflecting puck
  	result = math.pi - 2*alpha - theta

	-- compute the actual velocity components by multiplying
 	-- with the corresponding multipliers.

	puck_velocity.x = xmultiplier*math.abs(val*math.cos(result))
  	puck_velocity.y = ymultiplier*math.abs(val*math.sin(result))
end

--function for options menu
function menu()
   selectedOptionNumber = 0
   deactiveColor = Color.new(175, 175, 175)
   activeColor = Color.new(0, 0, 255)
   oldPad = Controls.read()
   while true do
      -- screen:clear()
      screen:blit(0, 0, menuimg,  false)
      y = 0
      selectedOptionValues = nil
      selectedOptionIndex = nil
      selectedOptionName = nil
      for optionKey, possibleOption in possibleOptions do
         color = deactiveColor
         if selectedOptionNumber == y then
            color = activeColor
            selectedOptionValues = possibleOption.values
         end
         screen:print(110, y * 30 + 60, possibleOption.displayName, color)
         for i, value in possibleOption.values do
            color = deactiveColor
            if options[optionKey] == value then
               color = activeColor
               if selectedOptionNumber == y then
                  selectedOptionIndex = i
                  selectedOptionName = optionKey
               end
            end
            screen:print(i * 60 + 250, y * 30 + 60, value, color)
         end
         y = y + 1
      end

      pad = Controls.read()
      if pad ~= oldPad then
         if pad:start() or pad:cross() then
              screen.waitVblankStart(10)
              break
         end
         if pad:up() then
            selectedOptionNumber = selectedOptionNumber - 1
            if selectedOptionNumber < 0 then selectedOptionNumber = y - 1 end
         end
         if pad:down() then
            selectedOptionNumber = selectedOptionNumber + 1
            if selectedOptionNumber >= y then selectedOptionNumber = 0 end
         end
         len = table.getn(selectedOptionValues)
         if pad:left() then
            selectedOptionIndex = selectedOptionIndex - 1
            if selectedOptionIndex <= 0 then selectedOptionIndex = len end
            options[selectedOptionName] = selectedOptionValues[selectedOptionIndex]
         end
         if pad:right() then
            selectedOptionIndex = selectedOptionIndex + 1
            if selectedOptionIndex > len then selectedOptionIndex = 1 end
            options[selectedOptionName] = selectedOptionValues[selectedOptionIndex]
         end
         oldPad = pad
      end
      screen:print(103, 240, "Puck Speed takes effect after the next goal.", red)
      screen.waitVblankStart()
      screen.flip()

      selectedMusic = (options["music"])
      if songplaying ~= selectedMusic then
         if selectedMusic == 1 then
            Music.playFile("song1.xm", true)
            songplaying = 1
         elseif selectedMusic == 2 then
            Music.playFile("song2.xm", true)
            songplaying = 2
         elseif selectedMusic == 3 then
            Music.playFile("song3.xm", true)
            songplaying = 3
         end
      end
   end
end 

-- function dumb ass ai

function ai()
   if puck_center.y < paddle_center[2].y then
      paddle[2].ya = paddle[2].ya -accel
   elseif puck_center.y > paddle_center[2].y then
      paddle[2].ya = paddle[2].ya +accel
   end
   
   aix = math.random(1,2)
   if aix == 1 and puck_center.x then
      paddle[2].xa = paddle[2].xa +accel
   else
      paddle[2].xa = paddle[2].xa -accel
   end
end







-- function game over
function gameover()
loopgameover = true
   while loopgameover do
      if selectedBackground == 1 and selectedGoalSize == 1 then
         screen:blit(0, 0, background,  false)
      elseif selectedBackground == 2 and selectedGoalSize == 1 then
         screen:blit(0, 0, background2,  false)
      elseif selectedBackground == 1 and selectedGoalSize == 2 then
         screen:blit(0, 0, backgroundlarge,  false)
      elseif selectedBackground == 2 and selectedGoalSize == 2 then
         screen:blit(0, 0, background2large,  false)
      end
      screen:print(180, 15, score2, red)
      screen:print(295, 15, score1, red)
      screen:print(194, 50, "GAME    OVER", black)
      screen:print(109, 250, "PRESS R BUTTON TO START A NEWGAME", black)
      screen.waitVblankStart()
      screen.flip()
      resetpad = Controls.read()
      if resetpad:r() then
         score1 = 0
         score2 = 0
         
         loopgameover = false
         return "reset"
      end
   end
end

function getready()

timeout = 0
while timeout < (2 * 60) do
    timeout = timeout + 1

	if keyboardControl() == "menu" then
    menu()
   end

   puck_pos.x = 224
	puck_pos.y = 120

   selectedBackground = (options["background"])
   selectedGoalSize = (options["goalsize"])
   if selectedBackground == 1 and selectedGoalSize == 1 then
	screen:blit(0, 0, background,  false)
   elseif selectedBackground == 2 and selectedGoalSize == 1 then
   screen:blit(0, 0, background2,  false)
   elseif selectedBackground == 1 and selectedGoalSize == 2 then
   screen:blit(0, 0, backgroundlarge,  false)
   elseif selectedBackground == 2 and selectedGoalSize == 2 then
   screen:blit(0, 0, background2large,  false)
   end

   screen:blit(paddle[1].x, paddle[1].y, paddleimg)
	screen:blit(paddle[2].x, paddle[2].y, paddleimg)
	screen:blit(puck_pos.x, puck_pos.y, puckimg)
	screen:print(180, 15, score2, red)
	screen:print(295, 15, score1, red)
   screen:print(201, 222, "Get Ready!", black)
   screen.waitVblankStart()
	screen.flip()

   paddle[1].x = paddle[1].x + paddle[1].xa
	paddle[1].y = paddle[1].y + paddle[1].ya
	paddle[2].x = paddle[2].x + paddle[2].xa
	paddle[2].y = paddle[2].y + paddle[2].ya

-- friction
	for player, coords in ipairs(paddle) do
		paddle[player].xa = 0.94*paddle[player].xa
		paddle[player].ya = 0.94*paddle[player].ya
	end

   paddlemaxborder()
end
	puck_velocity.y = math.random(-(puckvel), puckvel)
   puck_velocity.x = math.random(1,2)
   if puck_velocity.x == 2 then
   puck_velocity.x = puckvel
   else
   puck_velocity.x = -(puckvel)
   end
end

-- Function for main menu
function mainmenu()
oldmainMenuPad = Controls.read()
mainMenuSelection = 1
loopmainmenu = true
while loopmainmenu do
      screen:blit(0, 0, mainmenuimg,  false)
   if mainMenuSelection == 1 then
      screen:blit(130, 108, paddleimg)
      screen:blit(316, 108, paddleimg)
   elseif mainMenuSelection == 2 then
      screen:blit(123, 158, paddleimg)
      screen:blit(328, 158, paddleimg)
   elseif mainMenuSelection == 3 then
      screen:blit(135, 207, paddleimg)
      screen:blit(315, 207, paddleimg)
   end

   screen.waitVblankStart()
   screen.flip()

   mainMenuPad = Controls.read()
   if mainMenuPad ~= oldmainMenuPad then
      if mainMenuPad:down() then
         mainMenuSelection = mainMenuSelection + 1
         if mainMenuSelection > 3 then
            mainMenuSelection = 1
         end
      end
      if mainMenuPad:up()then
         mainMenuSelection = mainMenuSelection - 1
         if mainMenuSelection < 1 then
         mainMenuSelection = 3
         end
      end
      if mainMenuPad:cross() or mainMenuPad:start() then
         if mainMenuSelection == 1 then
            players = 1
            score1 = 0
            score2 = 0
            	paddle[1].x = 70
               paddle[1].y = 120
               paddle[2].x = 378
               paddle[2].y = 120
            getready()
            loopmainmenu = false
         elseif mainMenuSelection == 2 then
            players = 2
            score1 = 0
            score2 = 0
            	paddle[1].x = 70
               paddle[1].y = 120
               paddle[2].x = 378
               paddle[2].y = 120
            getready()
            loopmainmenu = false
         elseif mainMenuSelection == 3 then
            menu()
         end
      end
      oldmainMenuPad = mainMenuPad
   end
 
   end
end 
   




-- Game loop
	
	score1 = 0
	score2 = 0
	
 	screen:blit(0, 0, splash,  false)
	screen.waitVblankStart()
	screen.flip()
   boltsnd:play()
	screen.waitVblankStart(240)
	screen.flip()
   Music.volume(128)
   Music.playFile("song1.xm", true)
   songplaying = 1

mainmenu()  --Calls the main menu function

while true do
   selectedGoalSize = (options["goalsize"])
   if selectedGoalSize == 1 then
      if isPuckInGoal() == "true" then
         if score1 == 7 or score2 == 7 then
            if gameover() == "reset" then
               getready()
            end
         else
            getready()
         end
      end
   else
      if isPuckInGoal2() == "true" then
         if score1 == 7 or score2 == 7 then
               if gameover() == "reset" then
               getready()
            end
         else
            getready()
         end
      end
   end
   
   
	if keyboardControl() == "mmenu" then
    mainmenu()
   end

-- call ai function if one player
   if players == 1 then
      ai()
   end

   
-- Paddle Speed Selection
   selectedPaddleSpeed = (options["paddlespeed"])
   if selectedPaddleSpeed == 1 then
      accel = .4
      accela = .4
   elseif selectedPaddleSpeed == 2 then
      accel = .6
      accela = 1
   elseif selectedPaddleSpeed == 3 then
      accel = .8
      accela = 2
   end

-- Puck Speed Selection
   selectedPuckSpeed = (options["puckspeed"])
   if selectedPuckSpeed == 1 then
      puckvel = 4
   elseif selectedPuckSpeed == 2 then
      puckvel = 6
   elseif selectedPuckSpeed == 3 then
      puckvel = 8
   end

-- Background selection
   selectedBackground = (options["background"])
   selectedGoalSize = (options["goalsize"])
   if selectedBackground == 1 and selectedGoalSize == 1 then
	screen:blit(0, 0, background,  false)
   elseif selectedBackground == 2 and selectedGoalSize == 1 then
   screen:blit(0, 0, background2,  false)
   elseif selectedBackground == 1 and selectedGoalSize == 2 then
   screen:blit(0, 0, backgroundlarge,  false)
   elseif selectedBackground == 2 and selectedGoalSize == 2 then
   screen:blit(0, 0, background2large,  false)
   end


	screen:print(180, 15, score2, red)
	screen:print(295, 15, score1, red)

	
	paddle[1].x = paddle[1].x + paddle[1].xa
	paddle[1].y = paddle[1].y + paddle[1].ya
	paddle[2].x = paddle[2].x + paddle[2].xa
	paddle[2].y = paddle[2].y + paddle[2].ya

   selectedGoalSize = (options["goalsize"])
	if selectedGoalSize == 1 then
      didPuckWallCollide()
   else
      didPuckWallCollide2()
   end

	if hasPuckPaddleCollided() == "collide1" then
	ChangePuckVelocity1()
	elseif hasPuckPaddleCollided() == "collide2" then
	ChangePuckVelocity2()
	end

	-- friction
	for player, coords in ipairs(paddle) do
		paddle[player].xa = 0.94*paddle[player].xa
		paddle[player].ya = 0.94*paddle[player].ya
	end
	puck_pos.x = puck_pos.x + puck_velocity.x
	puck_pos.y = puck_pos.y + puck_velocity.y

	paddlemaxborder()

	screen:blit(paddle[1].x, paddle[1].y, paddleimg)
	screen:blit(paddle[2].x, paddle[2].y, paddleimg)
	screen:blit(puck_pos.x, puck_pos.y, puckimg)
	
   puck_center.x = puck_pos.x + 16
	puck_center.y = puck_pos.y + 16
	paddle_center[1].x = paddle[1].x + 16
	paddle_center[1].y = paddle[1].y + 16
	paddle_center[2].x = paddle[2].x + 16
	paddle_center[2].y = paddle[2].y + 16
	
   screen.waitVblankStart()
	screen.flip()
end
